package Table;

import java.util.ArrayList;
import java.util.ConcurrentModificationException;

/**
 * This class needs to manage an ArrayList of Entry objects.  It needs a get method that takes a key and returns
 * its corresponding value, or null of the key is not in the arraylist.  It needs a put method that takes a key and value
 * and makes an entry with key, value.  NOTE: There cannot be two entries with the same key.
 * It also needs a remove method which takes a key and, if that key exists in the arraylist, removes that item.
 * Void return on `remove`.
 */
public class Table<K, V> {
    private ArrayList<Entry> entries;
    private Entry entry;

    public Table() {
        this.entries = new ArrayList<>();
    }

    public V get(K k) {
        for(Entry entry : entries)
            if(entry.getKey().equals(k)) {
                return (V)entry.getValue();
            }
        return null;
    }

    public void put(K k, V v) {
        for(Entry entry : entries) {
            if (entry.getKey().equals(k)) entry.setValue(v);
        }
        entries.add(new Entry(k, v));
    }

    public void remove(K k) throws Exception{
        try{
            for(int i = 0; i < entries.size(); i++)
                if (entries.get(i).getKey().equals(k)) entries.remove(i);
        }catch (NullPointerException e) {  }
    }
}
